/* Monitor.c generated by valac 0.40.7, the Vala compiler
 * generated from Monitor.vala, do not modify */

/*
* Copyright (c) 2013-2017 elementary LLC. (http://launchpad.net/switchboard-plug-applications)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 2 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*
* Authored by: Julien Spautz <spautz.julien@gmail.com>
*/


#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>


#define STARTUP_PORT_TYPE_MONITOR (startup_port_monitor_get_type ())
#define STARTUP_PORT_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), STARTUP_PORT_TYPE_MONITOR, StartupPortMonitor))
#define STARTUP_PORT_IS_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), STARTUP_PORT_TYPE_MONITOR))
#define STARTUP_PORT_MONITOR_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), STARTUP_PORT_TYPE_MONITOR, StartupPortMonitorIface))

typedef struct _StartupPortMonitor StartupPortMonitor;
typedef struct _StartupPortMonitorIface StartupPortMonitorIface;
enum  {
	STARTUP_PORT_MONITOR_FILE_CREATED_SIGNAL,
	STARTUP_PORT_MONITOR_FILE_DELETED_SIGNAL,
	STARTUP_PORT_MONITOR_FILE_EDITED_SIGNAL,
	STARTUP_PORT_MONITOR_NUM_SIGNALS
};
static guint startup_port_monitor_signals[STARTUP_PORT_MONITOR_NUM_SIGNALS] = {0};

#define STARTUP_BACKEND_TYPE_MONITOR (startup_backend_monitor_get_type ())
#define STARTUP_BACKEND_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), STARTUP_BACKEND_TYPE_MONITOR, StartupBackendMonitor))
#define STARTUP_BACKEND_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), STARTUP_BACKEND_TYPE_MONITOR, StartupBackendMonitorClass))
#define STARTUP_BACKEND_IS_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), STARTUP_BACKEND_TYPE_MONITOR))
#define STARTUP_BACKEND_IS_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), STARTUP_BACKEND_TYPE_MONITOR))
#define STARTUP_BACKEND_MONITOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), STARTUP_BACKEND_TYPE_MONITOR, StartupBackendMonitorClass))

typedef struct _StartupBackendMonitor StartupBackendMonitor;
typedef struct _StartupBackendMonitorClass StartupBackendMonitorClass;
typedef struct _StartupBackendMonitorPrivate StartupBackendMonitorPrivate;
enum  {
	STARTUP_BACKEND_MONITOR_0_PROPERTY,
	STARTUP_BACKEND_MONITOR_NUM_PROPERTIES
};
static GParamSpec* startup_backend_monitor_properties[STARTUP_BACKEND_MONITOR_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _StartupPortMonitorIface {
	GTypeInterface parent_iface;
};

struct _StartupBackendMonitor {
	GObject parent_instance;
	StartupBackendMonitorPrivate * priv;
};

struct _StartupBackendMonitorClass {
	GObjectClass parent_class;
};

struct _StartupBackendMonitorPrivate {
	GFileMonitor* monitor;
};


static gpointer startup_backend_monitor_parent_class = NULL;
static StartupPortMonitorIface * startup_backend_monitor_startup_port_monitor_parent_iface = NULL;

GType startup_port_monitor_get_type (void) G_GNUC_CONST;
GType startup_backend_monitor_get_type (void) G_GNUC_CONST;
#define STARTUP_BACKEND_MONITOR_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), STARTUP_BACKEND_TYPE_MONITOR, StartupBackendMonitorPrivate))
StartupBackendMonitor* startup_backend_monitor_new (void);
StartupBackendMonitor* startup_backend_monitor_construct (GType object_type);
static void startup_backend_monitor_setup (StartupBackendMonitor* self);
gchar* startup_utils_get_user_startup_dir (void);
static void startup_backend_monitor_on_change_occurred (StartupBackendMonitor* self,
                                                 GFile* file,
                                                 GFile* dest,
                                                 GFileMonitorEvent event);
static void _startup_backend_monitor_on_change_occurred_g_file_monitor_changed (GFileMonitor* _sender,
                                                                         GFile* file,
                                                                         GFile* other_file,
                                                                         GFileMonitorEvent event_type,
                                                                         gpointer self);
gboolean startup_utils_is_desktop_file (const gchar* name);
static void startup_backend_monitor_finalize (GObject * obj);


static void
startup_port_monitor_default_init (StartupPortMonitorIface * iface)
{
	startup_port_monitor_signals[STARTUP_PORT_MONITOR_FILE_CREATED_SIGNAL] = g_signal_new ("file-created", STARTUP_PORT_TYPE_MONITOR, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__STRING, G_TYPE_NONE, 1, G_TYPE_STRING);
	startup_port_monitor_signals[STARTUP_PORT_MONITOR_FILE_DELETED_SIGNAL] = g_signal_new ("file-deleted", STARTUP_PORT_TYPE_MONITOR, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__STRING, G_TYPE_NONE, 1, G_TYPE_STRING);
	startup_port_monitor_signals[STARTUP_PORT_MONITOR_FILE_EDITED_SIGNAL] = g_signal_new ("file-edited", STARTUP_PORT_TYPE_MONITOR, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__STRING, G_TYPE_NONE, 1, G_TYPE_STRING);
}


GType
startup_port_monitor_get_type (void)
{
	static volatile gsize startup_port_monitor_type_id__volatile = 0;
	if (g_once_init_enter (&startup_port_monitor_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (StartupPortMonitorIface), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) startup_port_monitor_default_init, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
		GType startup_port_monitor_type_id;
		startup_port_monitor_type_id = g_type_register_static (G_TYPE_INTERFACE, "StartupPortMonitor", &g_define_type_info, 0);
		g_type_interface_add_prerequisite (startup_port_monitor_type_id, G_TYPE_OBJECT);
		g_once_init_leave (&startup_port_monitor_type_id__volatile, startup_port_monitor_type_id);
	}
	return startup_port_monitor_type_id__volatile;
}


StartupBackendMonitor*
startup_backend_monitor_construct (GType object_type)
{
	StartupBackendMonitor * self = NULL;
	self = (StartupBackendMonitor*) g_object_new (object_type, NULL);
	startup_backend_monitor_setup (self);
	return self;
}


StartupBackendMonitor*
startup_backend_monitor_new (void)
{
	return startup_backend_monitor_construct (STARTUP_BACKEND_TYPE_MONITOR);
}


static void
_startup_backend_monitor_on_change_occurred_g_file_monitor_changed (GFileMonitor* _sender,
                                                                    GFile* file,
                                                                    GFile* other_file,
                                                                    GFileMonitorEvent event_type,
                                                                    gpointer self)
{
	startup_backend_monitor_on_change_occurred ((StartupBackendMonitor*) self, file, other_file, event_type);
}


static const gchar*
string_to_string (const gchar* self)
{
	const gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	result = self;
	return result;
}


static void
startup_backend_monitor_setup (StartupBackendMonitor* self)
{
	gchar* startup_dir = NULL;
	gchar* _tmp0_;
	GFile* file = NULL;
	GFile* _tmp1_;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = startup_utils_get_user_startup_dir ();
	startup_dir = _tmp0_;
	_tmp1_ = g_file_new_for_path (startup_dir);
	file = _tmp1_;
	{
		GFileMonitor* _tmp2_ = NULL;
		GFileMonitor* _tmp3_;
		GFileMonitor* _tmp4_;
		GFileMonitor* _tmp5_;
		_tmp3_ = g_file_monitor (file, G_FILE_MONITOR_NONE, NULL, &_inner_error_);
		_tmp2_ = _tmp3_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			goto __catch1_g_error;
		}
		_tmp4_ = _tmp2_;
		_tmp2_ = NULL;
		_g_object_unref0 (self->priv->monitor);
		self->priv->monitor = _tmp4_;
		_tmp5_ = self->priv->monitor;
		g_signal_connect_object (_tmp5_, "changed", (GCallback) _startup_backend_monitor_on_change_occurred_g_file_monitor_changed, self, 0);
		_g_object_unref0 (_tmp2_);
	}
	goto __finally1;
	__catch1_g_error:
	{
		GError* e = NULL;
		const gchar* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
		GError* _tmp9_;
		const gchar* _tmp10_;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp6_ = string_to_string (startup_dir);
		_tmp7_ = g_strconcat ("Failed monitoring startup directory ", _tmp6_, NULL);
		_tmp8_ = _tmp7_;
		g_warning ("Monitor.vala:44: %s", _tmp8_);
		_g_free0 (_tmp8_);
		_tmp9_ = e;
		_tmp10_ = _tmp9_->message;
		g_warning ("Monitor.vala:45: %s", _tmp10_);
		_g_error_free0 (e);
	}
	__finally1:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		_g_object_unref0 (file);
		_g_free0 (startup_dir);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
	_g_object_unref0 (file);
	_g_free0 (startup_dir);
}


static void
startup_backend_monitor_on_change_occurred (StartupBackendMonitor* self,
                                            GFile* file,
                                            GFile* dest,
                                            GFileMonitorEvent event)
{
	gchar* path = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (file != NULL);
	_tmp0_ = g_file_get_path (file);
	path = _tmp0_;
	_tmp1_ = path;
	if (startup_utils_is_desktop_file (_tmp1_) == FALSE) {
		_g_free0 (path);
		return;
	}
	if (event == G_FILE_MONITOR_EVENT_CREATED) {
		const gchar* _tmp2_;
		_tmp2_ = path;
		g_signal_emit ((StartupPortMonitor*) self, startup_port_monitor_signals[STARTUP_PORT_MONITOR_FILE_CREATED_SIGNAL], 0, _tmp2_);
	} else {
		if (event == G_FILE_MONITOR_EVENT_DELETED) {
			const gchar* _tmp3_;
			_tmp3_ = path;
			g_signal_emit ((StartupPortMonitor*) self, startup_port_monitor_signals[STARTUP_PORT_MONITOR_FILE_DELETED_SIGNAL], 0, _tmp3_);
		} else {
			if (event == G_FILE_MONITOR_EVENT_CHANGED) {
				const gchar* _tmp4_;
				_tmp4_ = path;
				g_signal_emit ((StartupPortMonitor*) self, startup_port_monitor_signals[STARTUP_PORT_MONITOR_FILE_EDITED_SIGNAL], 0, _tmp4_);
			}
		}
	}
	_g_free0 (path);
}


static void
startup_backend_monitor_class_init (StartupBackendMonitorClass * klass)
{
	startup_backend_monitor_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (StartupBackendMonitorPrivate));
	G_OBJECT_CLASS (klass)->finalize = startup_backend_monitor_finalize;
}


static void
startup_backend_monitor_startup_port_monitor_interface_init (StartupPortMonitorIface * iface)
{
	startup_backend_monitor_startup_port_monitor_parent_iface = g_type_interface_peek_parent (iface);
}


static void
startup_backend_monitor_instance_init (StartupBackendMonitor * self)
{
	self->priv = STARTUP_BACKEND_MONITOR_GET_PRIVATE (self);
}


static void
startup_backend_monitor_finalize (GObject * obj)
{
	StartupBackendMonitor * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, STARTUP_BACKEND_TYPE_MONITOR, StartupBackendMonitor);
	_g_object_unref0 (self->priv->monitor);
	G_OBJECT_CLASS (startup_backend_monitor_parent_class)->finalize (obj);
}


GType
startup_backend_monitor_get_type (void)
{
	static volatile gsize startup_backend_monitor_type_id__volatile = 0;
	if (g_once_init_enter (&startup_backend_monitor_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (StartupBackendMonitorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) startup_backend_monitor_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (StartupBackendMonitor), 0, (GInstanceInitFunc) startup_backend_monitor_instance_init, NULL };
		static const GInterfaceInfo startup_port_monitor_info = { (GInterfaceInitFunc) startup_backend_monitor_startup_port_monitor_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		GType startup_backend_monitor_type_id;
		startup_backend_monitor_type_id = g_type_register_static (G_TYPE_OBJECT, "StartupBackendMonitor", &g_define_type_info, 0);
		g_type_add_interface_static (startup_backend_monitor_type_id, STARTUP_PORT_TYPE_MONITOR, &startup_port_monitor_info);
		g_once_init_leave (&startup_backend_monitor_type_id__volatile, startup_backend_monitor_type_id);
	}
	return startup_backend_monitor_type_id__volatile;
}



